/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.smartitengineering.demo.selectionsuite.myeditor;

import com.smartitengineering.demo.selectionsuite.api.person.PersonNode;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Logger;
import org.openide.explorer.ExplorerUtils;
import org.openide.nodes.AbstractNode;
import org.openide.util.Lookup;
import org.openide.util.Lookup.Template;
import org.openide.util.LookupEvent;
import org.openide.util.LookupListener;
import org.openide.util.NbBundle;
import org.openide.util.Utilities;
import org.openide.windows.TopComponent;
import org.openide.windows.WindowManager;

/**
 * Top component which displays something.
 */
final class MyEditorTopComponent
    extends TopComponent {

    private static MyEditorTopComponent instance;
    /** path to the icon used by the component and its open action */
    static final String ICON_PATH = "com/smartitengineering/demo/selectionsuite/myeditor/person_icon.gif";
    private static final String PREFERRED_ID = "MyEditorTopComponent";

    private MyEditorTopComponent() {
        initComponents();
        setName(NbBundle.getMessage(MyEditorTopComponent.class,
            "CTL_MyEditorTopComponent"));
        setToolTipText(NbBundle.getMessage(MyEditorTopComponent.class,
            "HINT_MyEditorTopComponent"));
        AbstractNode node = new AbstractNode(PersonNode.getRootPersonChildren());
        node.setHidden(true);
        node.setIconBaseWithExtension("com/smartitengineering/demo/selectionsuite/myapi/person_icon.gif");
        personExplorer.getExplorerManager().setRootContext(node);
        personTreeView.setRootVisible(false);
        associateLookup(ExplorerUtils.createLookup(personExplorer.getExplorerManager(), personExplorer.getActionMap()));
        setIcon(Utilities.loadImage(ICON_PATH, true));
    }

    @Override
    public boolean canClose() {
        return false;
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        personExplorer = new com.smartitengineering.demo.selectionsuite.myeditor.ExplorerPanel();
        personTreeView = new org.openide.explorer.view.BeanTreeView();
        petsExplorer = new com.smartitengineering.demo.selectionsuite.myeditor.ExplorerPanel();
        petListView = new org.openide.explorer.view.ListView();

        javax.swing.GroupLayout personExplorerLayout = new javax.swing.GroupLayout(personExplorer);
        personExplorer.setLayout(personExplorerLayout);
        personExplorerLayout.setHorizontalGroup(
            personExplorerLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(personExplorerLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(personTreeView, javax.swing.GroupLayout.DEFAULT_SIZE, 221, Short.MAX_VALUE)
                .addContainerGap())
        );
        personExplorerLayout.setVerticalGroup(
            personExplorerLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(personExplorerLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(personTreeView, javax.swing.GroupLayout.PREFERRED_SIZE, 227, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout petsExplorerLayout = new javax.swing.GroupLayout(petsExplorer);
        petsExplorer.setLayout(petsExplorerLayout);
        petsExplorerLayout.setHorizontalGroup(
            petsExplorerLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(petsExplorerLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(petListView, javax.swing.GroupLayout.DEFAULT_SIZE, 188, Short.MAX_VALUE)
                .addContainerGap())
        );
        petsExplorerLayout.setVerticalGroup(
            petsExplorerLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(petsExplorerLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(petListView, javax.swing.GroupLayout.DEFAULT_SIZE, 227, Short.MAX_VALUE)
                .addContainerGap())
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addComponent(personExplorer, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGap(18, 18, 18)
                .addComponent(petsExplorer, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(personExplorer, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGap(212, 212, 212))
            .addGroup(layout.createSequentialGroup()
                .addComponent(petsExplorer, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
    }// </editor-fold>//GEN-END:initComponents
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private com.smartitengineering.demo.selectionsuite.myeditor.ExplorerPanel personExplorer;
    private org.openide.explorer.view.BeanTreeView personTreeView;
    private org.openide.explorer.view.ListView petListView;
    private com.smartitengineering.demo.selectionsuite.myeditor.ExplorerPanel petsExplorer;
    // End of variables declaration//GEN-END:variables
    /**
     * Gets default instance. Do not use directly: reserved for *.settings files only,
     * i.e. deserialization routines; otherwise you could get a non-deserialized instance.
     * To obtain the singleton instance, use {@link findInstance}.
     */
    public static synchronized MyEditorTopComponent getDefault() {
        if (instance == null) {
            instance = new MyEditorTopComponent();
        }
        return instance;
    }

    /**
     * Obtain the MyEditorTopComponent instance. Never call {@link #getDefault} directly!
     */
    public static synchronized MyEditorTopComponent findInstance() {
        TopComponent win = WindowManager.getDefault().findTopComponent(
            PREFERRED_ID);
        if (win == null) {
            Logger.getLogger(MyEditorTopComponent.class.getName()).warning(
                "Cannot find " + PREFERRED_ID +
                " component. It will not be located properly in the window system.");
            return getDefault();
        }
        if (win instanceof MyEditorTopComponent) {
            return (MyEditorTopComponent) win;
        }
        Logger.getLogger(MyEditorTopComponent.class.getName()).warning(
            "There seem to be multiple components with the '" + PREFERRED_ID +
            "' ID. That is a potential source of errors and unexpected behavior.");
        return getDefault();
    }

    @Override
    public int getPersistenceType() {
        return TopComponent.PERSISTENCE_ALWAYS;
    }
    private Lookup.Result<PersonNode> personNodes;
    private LookupListener listener;

    @Override
    public void componentOpened() {
        super.componentOpened();
        final Lookup actionsGlobalContext = Utilities.actionsGlobalContext();
        final Template<PersonNode> personNodeTemplate =
            new Lookup.Template<PersonNode>(PersonNode.class);
        personNodes = actionsGlobalContext.lookup(personNodeTemplate);
        listener = new LookupListener() {
            public void resultChanged(LookupEvent nodeEvent) {
                List<? extends PersonNode> nodes = new ArrayList<PersonNode>(
                    ((Lookup.Result<PersonNode>) nodeEvent.getSource()).allInstances());
                if (nodes != null && !nodes.isEmpty()) {
                    AbstractNode petNode = new AbstractNode(PersonNode.
                        getPersonPetChildren(nodes.get(0).getPerson()));
                    petNode.setHidden(true);
                    petsExplorer.getExplorerManager().setRootContext(petNode);
                }
            }
        };
        personNodes.addLookupListener(listener);
        personNodes.allInstances();
        
    }

    @Override
    public void componentClosed() {
        super.componentClosed();
        personNodes.removeLookupListener(listener);
    }

    /** replaces this in object stream */
    @Override
    public Object writeReplace() {
        return new ResolvableHelper();
    }

    @Override
    protected String preferredID() {
        return PREFERRED_ID;
    }

    final static class ResolvableHelper
        implements Serializable {

        private static final long serialVersionUID = 1L;

        public Object readResolve() {
            return MyEditorTopComponent.getDefault();
        }
    }
}
